'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const { limit, skip, sort, filters } = body;
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            query GetPeople($input: ListArguments!) {
                people(input: $input) {
                totalCount
                data {
                    _id
                    uuid
                    firstName
                    surname
                    middleName
                    sexCode
                    personRef
                    personTag
                    fatherName
                    motherName
                    countryCode
                    nationalIdentityId
                    birthPlace
                    birthDate
                    taxNo
                    birthname
                    expiryStarts
                    expiryEnds
                    createdAt
                    updatedAt
                }
            }
        }
        `;
        const variables = { input: { limit, skip, sort, filters } };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.people.data, totalCount: data.people.totalCount });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
